<script setup lang="ts">
import { useUpdateDataCampaignStore } from '../stores/updateDataCampaignStore';
import SdgButton from '../components/SdgButton.vue';
import { ref } from 'vue';
import { type Campaign } from '../stores/updateDataCampaignStore';
import { compareCampaigns, compareUpdatedPeople } from '@/libs/compareCampaigns';
import type { Person } from '@/types/Person';
import type { Update } from '../libs/compareCampaigns';

const updateDataCampaignStore = useUpdateDataCampaignStore();

const showAddCampaign = ref(false);
const showComparison = ref(false);
const newCampaignName = ref('');

let campaigns = ref<Campaign[]>([]);
const changedFields = ref<Update[]>([]);

const fetchCampaigns = async () => (campaigns.value = await updateDataCampaignStore.getCampaigns());
fetchCampaigns();

const addCampaign = () => {
  newCampaignName.value = 'newCampaign';
  showAddCampaign.value = true;
};

const saveCampaign = async () => {
  await updateDataCampaignStore.addCampaign(newCampaignName.value);
  showAddCampaign.value = false;
  fetchCampaigns();
};

const compare = async (campaignId: string) => {
  const previousData = campaigns.value.find((x) => x.id === campaignId);
  const currentData = await updateDataCampaignStore.getCurrentCampaignData();
  const comparison = compareCampaigns(previousData?.snapshot ?? ({} as Person[]), currentData);

  changedFields.value = compareUpdatedPeople(comparison.updated);
  showComparison.value = true;
};

const remove = async (campaignId: string) => {
  await updateDataCampaignStore.removeCampaign(campaignId);
  fetchCampaigns();
};
</script>

<template>
  <div class="grid p-8 m-8 text-xl place-items-center">
    <table class="p-4 text-xl bg-white border-separate shadow-ld">
      <thead>
        <tr>
          <th class="border">Campaign</th>
          <th class="border">Date</th>
          <th class="border">Compare</th>
          <th class="border">Remove</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="campaign in campaigns" :key="campaign.id">
          <td class="p-2 border">{{ campaign.name }}</td>
          <td class="p-2 border">{{ campaign.date }}</td>
          <td class="p-2 border">
            <SdgButton color="bg-green-600" @onClick="compare(campaign.id)">Compare</SdgButton>
          </td>
          <td class="p-2 border">
            <SdgButton color="bg-red-900" @onClick="remove(campaign.id)">Remove</SdgButton>
          </td>
        </tr>
      </tbody>
    </table>

    <div v-if="showComparison" class="p-4">
      <table class="p-4 text-xl bg-white border-separate shadow-ld">
        <thead>
          <tr>
            <th class="border">Name</th>
            <th class="border">Field</th>
            <th class="border">Previous</th>
            <th class="border">Current</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="field in changedFields" :key="`${field.displayName}${field.key}`">
            <td class="p-2 border">{{ field.displayName }}</td>
            <td class="p-2 border">{{ field.key }}</td>
            <td class="p-2 border">{{ field.previous }}</td>
            <td class="p-2 border">{{ field.current }}</td>
          </tr>
        </tbody>
      </table>
    </div>

    <SdgButton color="bg-red-900" @onClick="addCampaign">Add a campaign</SdgButton>
    <div v-if="showAddCampaign" class="p-4">
      <div>Campaign name: <input type="text" v-model="newCampaignName" class="border-2" /></div>
      <div><SdgButton color="bg-green-600" @onClick="saveCampaign">Save</SdgButton></div>
    </div>
  </div>
</template>
